﻿Public Class Eval

    '■Eval
    ''' <summary>
    ''' 文字列型の式を計算します
    ''' </summary>
    ''' <param name="s">文字列型の式</param>
    ''' <returns>倍精度浮動小数点型の答え</returns>
    Public Overloads Function Eval(s As String) As Double

        Try
            '手順1 括弧内を計算
            '宣言
            Dim kakko As Integer = 0
            Dim newS As String = ""
            Dim saved As String = ""

            'ループ内
            For i As Integer = 0 To s.Length - 1

                Select Case s.Chars(i)
                    Case "("
                        kakko += 1
                        If kakko >= 2 Then
                            saved += "("
                        End If
                    Case ")"
                        If kakko <= 0 Then
                            Throw New Exception("1:左括弧と右括弧の数が違います")
                        ElseIf kakko >= 2 Then
                            kakko -= 1
                            saved += ")"
                        Else
                            kakko -= 1
                            newS += CStr(Eval(saved))
                            saved = ""
                        End If
                    Case Else
                        If kakko >= 1 Then
                            saved += s.Chars(i)
                        Else
                            newS += s.Chars(i)
                        End If
                End Select

            Next

            If kakko >= 1 Then
                Throw New Exception("1:左括弧と右括弧の数が違います")
            Else
                s = newS
            End If

            'Chart 2 form array
            '手順2 配列化

            Dim previous As Boolean = True
            Dim MySuji As Double()
            Dim MyHugo As Char()
            Dim PutHugo As Integer = 0
            Dim str As String = ""

            For i As Integer = 0 To s.Length - 1
                Select Case s.Chars(i)
                    Case "^", "*", "/", "+"
                        If previous Then
                            Throw New Exception("4:符号｢" & s.Chars(i - 1) & s.Chars(i) & "｣は連続できません。")
                        Else
                            previous = True
                            ReDim Preserve MyHugo(PutHugo)
                            ReDim Preserve MySuji(PutHugo)
                            MyHugo(PutHugo) = s.Chars(i)
                            MySuji(PutHugo) = CDbl(str)
                            PutHugo += 1
                            str = ""
                        End If
                    Case "-"
                        If previous Then
                            previous = False
                            str += "-"
                        Else
                            previous = True
                            ReDim Preserve MyHugo(PutHugo)
                            ReDim Preserve MySuji(PutHugo)
                            MyHugo(PutHugo) = s.Chars(i)
                            MySuji(PutHugo) = CDbl(str)
                            PutHugo += 1
                            str = ""
                        End If
                    Case "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "."
                        previous = False
                        str += s.Chars(i)
                    Case Else
                        Throw New Exception("3:無効な文字" & ControlChars.Quote & _
                        s.Chars(i) & ControlChars.Quote & "が含まれています。")
                End Select
            Next
            If str = "" Then
                Throw New Exception("5:符号｢" & MyHugo(PutHugo - 1) & "｣で終わることはできません。")
            Else
                ReDim Preserve MySuji(PutHugo)
                MySuji(PutHugo) = CDbl(str)
            End If

            '手順3 べき乗の計算
            Dim place As Integer = 0
            If Not MyHugo = Nothing Then
                Do
                    If MyHugo.Length > place Then
                        If MyHugo(place) = "^" Then
                            MySuji(place) = MySuji(place) ^ MySuji(place + 1)
                            MySuji = ArrayRemove(MySuji, place + 1)
                            MyHugo = ArrayRemove(MyHugo, place)
                        Else
                            place += 1
                        End If
                    Else
                        Exit Do
                    End If
                Loop
            End If

            '手順4,5 その他の計算
            If Not MyHugo = Nothing Then
                place = 0
                Do
                    If MyHugo.Length > place Then
                        If MyHugo(place) = "*" Then
                            MySuji(place) = MySuji(place) * MySuji(place + 1)
                            MySuji = ArrayRemove(MySuji, place + 1)
                            MyHugo = ArrayRemove(MyHugo, place)
                        Else
                            place += 1
                        End If
                    Else
                        Exit Do
                    End If
                Loop
            End If
            If Not MyHugo = Nothing Then
                place = 0
                Do
                    If MyHugo.Length > place Then
                        If MyHugo(place) = "/" Then
                            MySuji(place) = MySuji(place) / MySuji(place + 1)
                            MySuji = ArrayRemove(MySuji, place + 1)
                            MyHugo = ArrayRemove(MyHugo, place)
                        Else
                            place += 1
                        End If
                    Else
                        Exit Do
                    End If
                Loop
            End If
            If Not MyHugo = Nothing Then
                place = 0
                Do
                    If MyHugo.Length > place Then
                        If MyHugo(place) = "+" Then
                            MySuji(place) = MySuji(place) + MySuji(place + 1)
                            MySuji = ArrayRemove(MySuji, place + 1)
                            MyHugo = ArrayRemove(MyHugo, place)
                        Else
                            place += 1
                        End If
                    Else
                        Exit Do
                    End If
                Loop
            End If
            If Not MyHugo = Nothing Then
                place = 0
                Do
                    If MyHugo.Length > place Then
                        If MyHugo(place) = "-" Then
                            MySuji(place) = MySuji(place) - MySuji(place + 1)
                            MySuji = ArrayRemove(MySuji, place + 1)
                            MyHugo = ArrayRemove(MyHugo, place)
                        Else
                            place += 1
                        End If
                    Else
                        Exit Do
                    End If
                Loop
            End If

            Return MySuji(0)
        Catch ex As Exception
            Throw New Exception("0:不明なエラー")
        End Try

    End Function

    Public Overloads Function Eval(s As String()) As Double()
        Dim e As Double()
        '以下一行警告防止措置
        ReDim e(0)
        For i As Integer = 0 To s.Length - 1
            ReDim Preserve e(i)
            e(i) = Eval(s(i))
        Next
        Return e
    End Function

    Private Overloads Function ArrayRemove(ByVal TargetArray As Double(), ByVal deleteIndex As Integer) As Double()

        '一時保管用配列   
        Dim newArray As Double()
        ReDim newArray(TargetArray.GetUpperBound(0) - 1)

        '一時保管用配列にすべてをコピーする   
        Array.Copy(TargetArray, 0, newArray, 0, deleteIndex)

        '一時保管用配列に削除対象の要素以降の値をコピーする   
        Array.Copy(TargetArray, deleteIndex + 1, newArray, deleteIndex, TargetArray.GetUpperBound(0) - deleteIndex)

        'オリジナルの配列の格納領域を再割り当て   
        ReDim TargetArray(newArray.GetUpperBound(0))

        '値を代入   
        Return newArray

    End Function

    Private Overloads Function ArrayRemove(ByVal TargetArray As Char(), ByVal deleteIndex As Integer) As Char()

        '一時保管用配列   
        Dim newArray As Char()
        ReDim newArray(TargetArray.GetUpperBound(0) - 1)

        '一時保管用配列にすべてをコピーする   
        Array.Copy(TargetArray, 0, newArray, 0, deleteIndex)

        '一時保管用配列に削除対象の要素以降の値をコピーする   
        Array.Copy(TargetArray, deleteIndex + 1, newArray, deleteIndex, TargetArray.GetUpperBound(0) - deleteIndex)

        'オリジナルの配列の格納領域を再割り当て   
        ReDim TargetArray(newArray.GetUpperBound(0))

        '値を代入   
        Return newArray

    End Function



End Class
